#!/bin/sh

### config

ENIGMA_ON=1
GEMINI_ON=1
SAT_XML_ON=1
ADDONS_ON=1
PLUGINS_ON=1
EPGDAT_ON=0
TAR_NAME=gemini_backup
DIRECTORY=/tmp
EPGDAT_FILE=/hdd/gemini.epg.dat
# end

AUTORELOAD=0

echo "#!/bin/sh" > /var/bin/n_addoninstall.sh

echo "${DIRECTORY}/${TAR_NAME}_`date +%d.%m.%Y`.tar.gz" > ${DIRECTORY}/${TAR_NAME}_log.txt
echo "" >> ${DIRECTORY}/${TAR_NAME}_log.txt

rm -rf ${DIRECTORY}/back_tmp
mkdir ${DIRECTORY}/back_tmp
rm -rf ${DIRECTORY}/${TAR_NAME}_`date +%d.%m.%Y`.tar.gz

### backup enigma

if [ $ENIGMA_ON -ne 0 ]; then
	for i in /var/tuxbox/config/enigma/* /etc/network/interfaces /var/tuxbox/tuxtxt/* /var/tuxbox/*.conf; do
		if [ -e "$i" ]; then
			etarline="$etarline $i"
		fi
	done
	rm -rf ${DIRECTORY}/ENIGMA_tmp
	mkdir -p ${DIRECTORY}/ENIGMA_tmp
	tar -czf ${DIRECTORY}/${TAR_NAME}_ENIGMA.tar.gz $etarline
	etarline=""
	tar -zxf ${DIRECTORY}/${TAR_NAME}_ENIGMA.tar.gz -C ${DIRECTORY}/ENIGMA_tmp
	rm -rf ${DIRECTORY}/${TAR_NAME}_ENIGMA.tar.gz
	rm -rf ${DIRECTORY}/ENIGMA_tmp/var/tuxbox/config/enigma/pictures/*
	rm -rf ${DIRECTORY}/ENIGMA_tmp/var/tuxbox/config/enigma/skins/*
	cp -pa ${DIRECTORY}/ENIGMA_tmp/* ${DIRECTORY}/back_tmp/
	rm -rf ${DIRECTORY}/ENIGMA_tmp
	AUTORELOAD=1
fi

### backup enigma finish


### backup gemini

if [ $GEMINI_ON -ne 0 ]; then
	if grep -qs 7020 /proc/bus/dreambox ; then
		for i in /var/etc/gemini* /var/etc/hddtemp.db /var/etc/stations.xml; do
			if [ -e "$i" ]; then
				gtarline="$gtarline $i"
			fi
		done
		echo "if ! grep -qs 7020 /proc/bus/dreambox ; then" >> /var/bin/n_addoninstall.sh
		echo "	cp /var/etc/gemini* /var/tuxbox/config/" >> /var/bin/n_addoninstall.sh
		echo "	cp /var/etc/hddtemp.db /var/tuxbox/config/" >> /var/bin/n_addoninstall.sh
		echo "	cp /var/etc/stations.xml /var/tuxbox/config/" >> /var/bin/n_addoninstall.sh
		echo "	rm -rf /var/etc/gemini*" >> /var/bin/n_addoninstall.sh
		echo "	rm -rf /var/etc/hddtemp.db" >> /var/bin/n_addoninstall.sh
		echo "	rm -rf /var/etc/stations.xml" >> /var/bin/n_addoninstall.sh
		echo "  sed 's/\/etc\/enigma/\/var\/tuxbox\/config\/enigma/' /var/tuxbox/config/enigma/userbouquets.tv.epl > /var/tuxbox/config/enigma/userbouquets.tv.epl.c" >> /var/bin/n_addoninstall.sh
		echo "  sed 's/\/etc\/enigma/\/var\/tuxbox\/config\/enigma/' /var/tuxbox/config/enigma/userbouquets.tv.epl > /var/tuxbox/config/enigma/userbouquets.radio.epl.c" >> /var/bin/n_addoninstall.sh
		echo "  sed 's/\/etc\/enigma/\/var\/tuxbox\/config\/enigma/' /var/tuxbox/config/enigma/userbouquets.tv.epl > /var/tuxbox/config/enigma/userbouquets.file.epl.c" >> /var/bin/n_addoninstall.sh
		echo "  rm /var/tuxbox/config/enigma/userbouquets.tv.epl" >> /var/bin/n_addoninstall.sh
		echo "  mv /var/tuxbox/config/enigma/userbouquets.tv.epl.c /var/tuxbox/config/enigma/userbouquets.tv.epl" >> /var/bin/n_addoninstall.sh
		echo "  rm /var/tuxbox/config/enigma/userbouquets.radio.epl" >> /var/bin/n_addoninstall.sh
		echo "  mv /var/tuxbox/config/enigma/userbouquets.radio.epl.c /var/tuxbox/config/enigma/userbouquets.radio.epl" >> /var/bin/n_addoninstall.sh
		echo "  rm /var/tuxbox/config/enigma/userbouquets.file.epl" >> /var/bin/n_addoninstall.sh
		echo "  mv /var/tuxbox/config/enigma/userbouquets.file.epl.c /var/tuxbox/config/enigma/userbouquets.file.epl" >> /var/bin/n_addoninstall.sh
		echo "fi" >> /var/bin/n_addoninstall.sh
	else
		for i in /var/tuxbox/config/gemini* /var/tuxbox/config/hddtemp.db /var/tuxbox/config/stations.xml; do
			if [ -e "$i" ]; then
				gtarline="$gtarline $i"
			fi
		done
		echo "if grep -qs 7020 /proc/bus/dreambox ; then" >> /var/bin/n_addoninstall.sh
		echo "	cp /var/tuxbox/config/gemini* /var/etc/" >> /var/bin/n_addoninstall.sh
		echo "	cp /var/tuxbox/config/hddtemp.db /var/etc/" >> /var/bin/n_addoninstall.sh
		echo "	cp /var/tuxbox/config/stations.xml /var/etc/" >> /var/bin/n_addoninstall.sh
		echo "	rm -rf /var/tuxbox/config/gemini*" >> /var/bin/n_addoninstall.sh
		echo "	rm -rf /var/tuxbox/config/hddtemp.db" >> /var/bin/n_addoninstall.sh
		echo "	rm -rf /var/tuxbox/stations.xml" >> /var/bin/n_addoninstall.sh
		echo "	sed 's/\/var\/tuxbox\/config\/enigma/\/etc\/enigma/' /etc/enigma/userbouquets.tv.epl > /etc/enigma/userbouquets.tv.epl.c" >> /var/bin/n_addoninstall.sh
		echo "	sed 's/\/var\/tuxbox\/config\/enigma/\/etc\/enigma/' /etc/enigma/userbouquets.tv.epl > /etc/enigma/userbouquets.radio.epl.c" >> /var/bin/n_addoninstall.sh
		echo "	sed 's/\/var\/tuxbox\/config\/enigma/\/etc\/enigma/' /etc/enigma/userbouquets.tv.epl > /etc/enigma/userbouquets.file.epl.c" >> /var/bin/n_addoninstall.sh
		echo "	rm /etc/enigma/userbouquets.tv.epl" >> /var/bin/n_addoninstall.sh
		echo "	mv /etc/enigma/userbouquets.tv.epl.c /etc/enigma/userbouquets.tv.epl" >> /var/bin/n_addoninstall.sh
		echo "	rm /etc/enigma/userbouquets.radio.epl" >> /var/bin/n_addoninstall.sh
		echo "	mv /etc/enigma/userbouquets.radio.epl.c /etc/enigma/userbouquets.radio.epl" >> /var/bin/n_addoninstall.sh
		echo "	rm /etc/enigma/userbouquets.file.epl" >> /var/bin/n_addoninstall.sh
		echo "	mv /etc/enigma/userbouquets.file.epl.c /etc/enigma/userbouquets.file.epl" >> /var/bin/n_addoninstall.sh
		echo "fi" >> /var/bin/n_addoninstall.sh
	fi
	for i in /var/script/*backup.sh /var/script/*userscript.sh /var/script/*script.sh; do
		if [ -e "$i" ]; then
			gtarline="$gtarline $i"
		fi
	done
	rm -rf ${DIRECTORY}/GEMINI_tmp
	mkdir -p ${DIRECTORY}/GEMINI_tmp
	tar -czf ${DIRECTORY}/${TAR_NAME}_GEMINI.tar.gz $gtarline
	gtarline=""
	tar -zxf ${DIRECTORY}/${TAR_NAME}_GEMINI.tar.gz -C ${DIRECTORY}/GEMINI_tmp
	rm -rf ${DIRECTORY}/${TAR_NAME}_GEMINI.tar.gz
	cp -pa ${DIRECTORY}/GEMINI_tmp/* ${DIRECTORY}/back_tmp/
	rm -rf ${DIRECTORY}/GEMINI_tmp
	AUTORELOAD=1
fi

### backup gemini finish


### backup satxml

if [ $SAT_XML_ON -ne 0 ]; then
	for i in /var/tuxbox/satellites.xml /var/tuxbox/cables.xml /var/tuxbox/terrestrial.xml; do
		if [ -e "$i" ]; then
			starline="$starline $i"
		fi
	done
	rm -rf ${DIRECTORY}/SAT_XML_tmp
	mkdir -p ${DIRECTORY}/SAT_XML_tmp
	tar -czf ${DIRECTORY}/${TAR_NAME}_SAT_XML.tar.gz $starline
	starline=""
	tar -zxf ${DIRECTORY}/${TAR_NAME}_SAT_XML.tar.gz -C ${DIRECTORY}/SAT_XML_tmp
	rm -rf ${DIRECTORY}/${TAR_NAME}_SAT_XML.tar.gz
	cp -pa ${DIRECTORY}/SAT_XML_tmp/* ${DIRECTORY}/back_tmp/
	rm -rf ${DIRECTORY}/SAT_XML_tmp
	AUTORELOAD=1
fi

### backup satxml finish


### backup addons

if [ $ADDONS_ON -ne 0 ]; then
	cd /var/uninstall
	for i in *; do
		while read bline
		do
			tmpline=`echo "$bline" | grep "^rm " | grep "/var" | sed "s/^.*\/var/\/var/"`
			if [ -e "$tmpline" ]; then
				atarline="$atarline $tmpline"
			fi
		done < $i
	done
	if grep -qs 7020 /proc/bus/dreambox ; then
		for i in /usr/lib/libcamdio.so.0; do
			if [ -e "$i" ]; then
				atarline="$atarline $i"
			fi
		done
	else
		for i in /var/lib/libcamdio.so.0; do
			if [ -e "$i" ]; then
				atarline="$atarline $i"
			fi
		done
	fi
	rm -rf ${DIRECTORY}/ADDONS_tmp
	mkdir -p ${DIRECTORY}/ADDONS_tmp
	if [ -e /var/tuxbox/scce ]; then
		mkdir -p ${DIRECTORY}/ADDONS_tmp/var/tuxbox 2>/dev/null
		ln -sf /var/scce ${DIRECTORY}/ADDONS_tmp/var/tuxbox/
	fi
	tar -czf ${DIRECTORY}/${TAR_NAME}_ADDONS.tar.gz $atarline
	atarline=""
	tar -zxf ${DIRECTORY}/${TAR_NAME}_ADDONS.tar.gz -C ${DIRECTORY}/ADDONS_tmp
	rm -rf ${DIRECTORY}/${TAR_NAME}_ADDONS.tar.gz
	cp -pa ${DIRECTORY}/ADDONS_tmp/* ${DIRECTORY}/back_tmp/
	rm -rf ${DIRECTORY}/ADDONS_tmp
	AUTORELOAD=1
fi

### backup addons finish

### backup plugins

if [ $PLUGINS_ON -ne 0 ]; then
	for i in /var/tuxbox/plugins/*.so /var/tuxbox/plugins/*.cfg; do
		if [ -e "$i" ]; then
			ptarline="$ptarline $i"
		fi
	done
	for i in /var/bin/tuxwet/* /var/tuxbox/config/rss/feeds.xml /var/tuxbox/config/weather/*; do
		if [ -e "$i" ]; then
			ptarline="$ptarline $i"
		fi
	done
	for i in /var/bin/epgrefresh.* /var/tuxbox/config/vlc.xml /var/tuxbox/config/vnc.conf /var/tuxbox/config/mv/*/*; do
		if [ -e "$i" ]; then
			ptarline="$ptarline $i"
		fi
	done
	for i in /var/tuxbox/config/enigma/pictures/* /var/tuxbox/config/enigma/skins/*; do
		if [ -e "$i" ]; then
			ptarline="$ptarline $i"
		fi
	done

	if ! grep -qs 7020 /proc/bus/dreambox ; then
		for i in /var/bin/tuxmaild /var/tuxbox/config/tuxmail/* /var/etc/enigma_*.sh; do
			if [ -e "$i" ]; then
				ptarline="$ptarline $i"
			fi
		done
	fi
	rm -rf ${DIRECTORY}/PLUGINS_tmp
	mkdir -p ${DIRECTORY}/PLUGINS_tmp
	tar -czf ${DIRECTORY}/${TAR_NAME}_PLUGINS.tar.gz $ptarline
	ptarline=""
	tar -zxf ${DIRECTORY}/${TAR_NAME}_PLUGINS.tar.gz -C ${DIRECTORY}/PLUGINS_tmp
	rm -rf ${DIRECTORY}/${TAR_NAME}_PLUGINS.tar.gz
	cp -pa ${DIRECTORY}/PLUGINS_tmp/* ${DIRECTORY}/back_tmp/
	rm -rf ${DIRECTORY}/PLUGINS_tmp
fi

### backup plugins finish

### backup epgdat

if [ $EPGDAT_ON -ne 0 ]; then
	for i in ${EPGDAT_FILE}*; do
		if [ -e "$i" ]; then
			etarline="$etarline $i"
		fi
	done
	rm -rf ${DIRECTORY}/EPGDAT_tmp
	mkdir -p ${DIRECTORY}/EPGDAT_tmp
	tar -czf ${DIRECTORY}/${TAR_NAME}_EPGDAT.tar.gz $etarline
	etarline=""
	tar -zxf ${DIRECTORY}/${TAR_NAME}_EPGDAT.tar.gz -C ${DIRECTORY}/EPGDAT_tmp
	rm -rf ${DIRECTORY}/${TAR_NAME}_EPGDAT.tar.gz
	cp -pa ${DIRECTORY}/EPGDAT_tmp/* ${DIRECTORY}/back_tmp/
	rm -rf ${DIRECTORY}/EPGDAT_tmp
	AUTORELOAD=1
fi

### backup epgdat finish


### backup autoreload

if [ $AUTORELOAD -ne 0 ]; then
	echo "killall -9 enigma" >> /var/bin/n_addoninstall.sh
	echo "rm -rf /var/bin/n_addoninstall.sh" >> /var/bin/n_addoninstall.sh
	chmod 755 /var/bin/n_addoninstall.sh
	mkdir -p ${DIRECTORY}/back_tmp/var/bin 2>/dev/null
	cp -pa /var/bin/n_addoninstall.sh ${DIRECTORY}/back_tmp/var/bin/
fi

### backup autoreload finish


### backup user

USER_ON=0
if [ $USER_ON -ne 0 ]; then
	for i in /var/bin/user/* /var/bla/user /var/user; do
		if [ -e "$i" ]; then
			utarline="$utarline $i"
		fi
	done
	rm -rf ${DIRECTORY}/USER_tmp
	mkdir -p ${DIRECTORY}/USER_tmp
	tar -czf ${DIRECTORY}/${TAR_NAME}_USER.tar.gz $utarline
	utarline=""
	tar -zxf ${DIRECTORY}/${TAR_NAME}_USER.tar.gz -C ${DIRECTORY}/USER_tmp
	rm -rf ${DIRECTORY}/${TAR_NAME}_USER.tar.gz
	cp -pa ${DIRECTORY}/USER_tmp/* ${DIRECTORY}/back_tmp/
	rm -rf ${DIRECTORY}/USER_tmp
fi

### backup user finish

### create tarball

if [ -e ${DIRECTORY}/back_tmp ]; then
	cd ${DIRECTORY}/back_tmp
	tar -czvf ${DIRECTORY}/${TAR_NAME}_`date +%d.%m.%Y`.tar.gz ./*  >> ${DIRECTORY}/${TAR_NAME}_log.txt
	rm -rf ${DIRECTORY}/back_tmp
fi
rm /var/bin/n_addoninstall.sh

### create tarball finish

exit 0
